@echo off
cls
set root=%1
set ccsid=%2
echo working with export in %root%

set /A is400=0
set /A hasccsid=0
setlocal ENABLEDELAYEDEXPANSION

FOR %%i IN (%root%\*.par) DO (
	echo ---------------
	echo working in file %%i
	set file=%%i
	set /A is400=0
	set /A hasccsid=0
	echo Check if AS400 job
	FOR /f "tokens=1*" %%j IN (%%i) DO (
		if NOT "!is400!"=="1" ( 
REM		echo compare with %%j
			if %%j=="V_400"  (
				set is400=1
			)
		)
	)

	if "!is400!"=="1" (
		echo IS an AS400 job, is there a ccsid...
		FOR /f "tokens=1*" %%j IN (%%i) DO (
			if %%j=="V_CCSID"  (
			    echo yes ccsid already present
				set hasccsid=1
			) else (
				echo No ccsid present
			)
		)
		copy %%i %%i.backup
		if exist %%i.new del %%i.new
		if "!hasccsid!"=="1" (
			echo Replacing existing ccsid by %ccsid%
REM     *** duplicate file content and if string is starting with "V_CCSID" replace it by the new CCSID ***
			FOR /f "tokens=*" %%j IN (%%i) DO (
				set line=%%j
				if "!line:~1,7!"=="V_CCSID" (
					echo "V_CCSID" "%2" >> %%i.new
				) else (
					echo %%j >> %%i.new
				)
			)			
		) else (
			echo Adding ccsid %ccsid%
REM     *** duplicate file content and add cssid before end ***
			FOR /f "tokens=*" %%j IN (%%i) DO (
				if "%%j"=="}" echo "V_CCSID" "%2" >> %%i.new
				echo %%j >> %%i.new
			)
		)
		del %%i
		move %%i.new %%i
		echo ""
	) else (
		echo is not an AS400 job, skipping
		echo ""
	)
)
endlocal



REM for f in $(find "$root" -name "*.par"); do
REM     as400job=$(grep "V_400" "$f" | wc -l)
REM 
REM     if [ $as400job -ge 1 ]; then
REM         echo "Processing $f"
REM         have_ccsid=$(grep "V_CCSID" "$f" | wc -l)
        
REM         if [ $have_ccsid -gt 1 ]; then
REM             echo "Error: unexpected number of V_CCSID lines!"
REM         elif [ $have_ccsid -eq 1 ]; then
REM             echo "Found V_CCSID already defined. Substituting..."
REM             sed -i "/V_CCSID/c \\\\t\"V_CCSID\" \"$ccsid\"" "$f"
REM         else
REM             echo "Inserting V_CCSID"
REM             sed -i "/V_400/a \\\\t\"V_CCSID\" \"$ccsid\"" "$f"
REM         fi
REM     else
REM         echo "Skipping $f"
REM     fi
REM done
